from sympy import IndexedBase, Matrix, Mul, Poly, floor, var, pprint, S
from sympy import rem, prod, degree_list, total_degree, apart, residue, series, together
from sympy import numbered_symbols, take, fps, collect, groebner, Rational
from sympy import sqf, sqf_list, quo, diff, integrate, sqrt, cos, Integral, together, cot, sin
from sympy.series.formal import compute_fps
from sympy.core.compatibility import range
from sympy.polys.monomials import monomial_deg
from sympy.polys.monomials import itermonomials
from sympy.polys.orderings import monomial_key
from sympy.polys.polytools import poly_from_expr
from sympy.functions.combinatorial.factorials import binomial

from itertools import combinations_with_replacement, combinations, product

from sympy import symbols, solve, factor, expand, simplify, nsimplify, solve_undetermined_coeffs

a, b, c, d, x, y, z = symbols('a, b, c, d, x, y, z')



f = (x**2 - 2) / (x**3 + 3*x**2 + 2*x)
print('f = ', f, '\n')
"""
print('f @ 0= ', fps(f, x, x0=0).truncate(), '\n')
print('f @ 0 = ', series(f, x, x0=0),'\n')
print('residue = ', residue( f, x, 0),'\n')

print('f @ -1 = ', fps(f, x, x0=-1).truncate(), '\n')
print('f @ -1 = ', series(f, x, x0=-1),'\n')
print('residue = ', residue( f, x, -1),'\n')


print('f @ -2 = ', fps(f, x, x0=-2).truncate(), '\n')
print('f @ -2 = ', series(f, x, x0=-2),'\n')
print('residue = ', residue( f, x, -2),'\n')

print('f = ', simplify(together(apart(f))), '\n')

## Residue computation method 1
print('Residue computation method 1' , '\n')

a0, a1, a2, f, f1, f2, f3, s1, s2, s3 = symbols('a0, a1, a2, f, f1, f2, f3, s1, s2, s3')

print(collect(expand(f1 * (x - s2) * (x - s3) + f2 * (x - s1) * (x - s3) +
       f3 * (x - s1) * (x - s2)), x), '\n')

print(simplify(f * (x + 2)).subs({x : -2}),'\n')

f = 1 / ( x**2 * (x + 1) )
print('f = ', f, '\n')
print('f = ', apart(f), '\n')

print(residue( f, x, 0), '\n')
print(residue( f, x, -1), '\n')

"""

p = 12*x**5 + 8*x**4 + 12*x**3 + 4*x**2 + 4*x + 4
q = x**6 + 2*x**5 + 3*x**4 + 4*x**3 + 3*x**2 + 2*x + 1

print('p = ', p, '\n')
print('q = ', q, '\n')
print('sqf(q) = ', sqf(q), '\n')
q1 = sqf_list(q)[1][0][0]
print('factor(q1) = ', factor(q1), '\n')
print('sqf_list(q) = q1 = ', q1, '\n')
q2= quo(q, q1)
print('q2 = quo(q, q1) = ', q2, '\n')

w = symbols('w')

coeffs_p1 = take( numbered_symbols(w), 3 )
print('coeffs_p1 = ', coeffs_p1, '\n')

p1 = sum( [coeffs_p1[i]*x**i for i in range(3)] )
print('p1 = ', p1, '\n')

coeffs_p2 = take( numbered_symbols(z), 3 )
print('coeffs_p2 = ', coeffs_p2, '\n')

p2 = sum( [coeffs_p2[i]*x**i for i in range(3)] )
print('p2 = ', p2, '\n')

s = diff( q1, x, 1 ) * q2 / q1
print('s = ', s, '\n')

t = (
    
        diff(p1, x, 1) * q2 - p1 * s + p2 * q1
        
            ).expand().collect(x)

print('t = ', t, '\n')

sols = solve_undetermined_coeffs( t - p, coeffs_p1 + coeffs_p2, x )
print('sols = ', sols, '\n')

p1 = p1.subs(sols)
print('p1 = ', p1, '\n')

p2 = p2.subs(sols)
print('p2 = ', p2, '\n')


print(integrate(sqrt(1 - cos(x)), x), '\n')

print(Integral(sqrt(1 - cos(x)), (x, 0, 6)).doit(), '\n')

print(together(integrate(1 / (x**4 + 1), x)), '\n')

print(cot(x/2).rewrite(sin), '\n')
